function main (inpargs)

'reinit'

'set mpdset mres'

color = c

cstorm = subwrd(inpargs,1)
iymdh  = subwrd(inpargs,2)
eymdh  = subwrd(inpargs,3)
dtype  = subwrd(inpargs,4)
color  = subwrd(inpargs,5)

_rundir='/home/rogers/data/models/jht/npvu/'
*_rundir='/home/rogers/data/models/jht/eta/'
_btrackdir='/home/rogers/data/models/jht/npvu/'

* _boxsize = size of box around storm in degrees.  For example, a 
* _boxsize of 2 means it's the center of the storm +/- 2 degrees.
* _units = "inches", "mm" or "cm"

_boxsize   = 2
_units     = inches
_drawstorm = y
_drawbox   = y
_filetype  = 1h
_plottype  = indiv

if (cstorm = '')
  say ' '
  say '+++ USAGE: accprcp.gs stormname iymdh eymdh dtype <colorflag>'
  say ' '
  say '    where:   stormname = isabel, floyd, etc (must be all lower case)'
  say '             iymdh     = starting yyyymmddhh'
  say '             eymdh     = ending yyyymmddhh'
  say '             dtype     = npvu, rcliper, gfdl, gfs, eta (only npvu'
  say '                         works for now)'
  say '             colorflag = c/g (optional; default = c)'
  say ' '
  return
endif

say ' '
say ' stormname   = 'cstorm
say ' iymdh       = 'iymdh
say ' eymdh       = 'eymdh
say ' data source = 'dtype
say ' colorflag   = 'color

_iyyyy = substr(iymdh,1,4)

*----------------------------------------------------
* Find the name of the ctl file and open it....

ctlymdh = findctl(cstorm)

if (ctlymdh = 99)
  say '!!! ERROR: STORM 'cstorm' NOT FOUND IN FUNCTION FINDCTL'
  say '!!!        Exiting....'
  return
else
  ctlname = dtype'.'ctlymdh'.'ctl
endif

say 'ctlname= 'ctlname
'open 'ctlname

*----------------------------------------------------
* Find the starting and ending time indeces.  Note that for
* the starting time, we increment tstart by 1.  This is 
* because if we are starting at, say, 2003091712, the precip
* record that we would read in for 2003091712 would contain
* the accumulated precip for 11z to 12z, which we don't want
* (we want to start with the precip for 12z to 13z).

'q file'
rec=sublin(result,5)
tsize=subwrd(rec,12)

t=1
while(t<=tsize)
  'set t 't
  'q dims'
  rec=sublin(result,5)
  grtime=subwrd(rec,6)
  gymdh = convtime(grtime)
  if(gymdh = iymdh) 
    tstart=t+1
  endif
  if(gymdh = eymdh)
    tend=t
  endif
  t=t+1
endwhile

say 'tstart= 'tstart 
say 'tend= 'tend


*----------------------------------------------------
* This call to getbnds returns the bounds surrounding the
* entire best track for the duration of this case.

rc = getbnds(cstorm)

say ' '
say 'After call to getbnds, grid boundaries around the best'
say 'track for the duration of this case are as follows: '
say '  _westlon  = '_westlon
say '  _eastlon  = '_eastlon
say '  _northlat = '_northlat
say '  _southlat = '_southlat

'set lon '_westlon' '_eastlon
'set lat '_southlat' '_northlat


*----------------------------------------------------
* Now loop through for each forecast hour and plot the 
* rainfall over the whole domain (at least, the domain
* that was just set in getbnds), and then calculate
* the amount of rain in the 4x4 degree box surrounding
* the current best track storm position.

'clear'
'set dbuff on'


totbxrain = 0

tindex = tstart
tbegin = tindex

while (tindex <= tend & ccont != n)

  'set t 'tindex

  'set parea 0.5 10.3 0.82 7.37'

  'q dims'
  rec=sublin(result,5)
  grtime=subwrd(rec,6)
  gymdh = convtime(grtime)

  rc = boxbound(cstorm,gymdh)

  if (rc != 0)
    say '!!! ERROR returned from boxbound; input time of'
    say '!!!      'gymdh' was not found in the best track file.'
    say '!!!      for storm 'cstorm
    return 95
  endif

*  if(dtype = eta)
*    'define prcptemp = APCPsfc(t+0)-APCPsfc(t-1)'
*  else
*    'define prcptemp = totprcp'
*  endif

*  'define prcptemp = totprcp'
*  rc = drawprcp(prcptemp)

*  say 'step 1'
  if (_filetype = 1h)

    if (_plottype = indiv)

*     FOR PLOTTING EACH INDIVIDUAL 1-HOURLY PRECIP ACCUMULATION

*      iftmod = math_fmod(ift,12)
      iftmod = mod(tindex,12)
      if (iftmod = 2)
*       This is the first time of a new 12-hour
*       accumulation block
*        'define prcptemp = totprcp'
        'define prcptemp = APCPsfc'
      else
        tnew = tindex
        told = tindex - 1
        say 'tnew= 'tnew'  told= 'told
*        'define prcptemp = totprcp(t='tnew') - totprcp(t='told')'
        'define prcptemp = APCPsfc(t='tnew') - APCPsfc(t='told')'
      endif
      rc = drawprcp(prcptemp)

    else

*     FOR PLOTTING RUNNING TOTAL ACCUMULATION FOR 1-HOURLY FILES

      if (tindex < 14)
        say 'A'
*        'define prcptemp=totprcp(t='tindex')'
        'define prcptemp=APCPsfc(t='tindex')'
        rc = drawprcp(prcptemp)
      else
        if (tindex < 26)
          say 'B'
*          'define p1tot = totprcp(t=13)'
*          'define p2run = totprcp(t='tindex')'
          'define p1tot = APCPsfc(t=13)'
          'define p2run = APCPsfc(t='tindex')'
          'define prcptemp = p1tot + p2run'
          rc = drawprcp(prcptemp)
        else
          say 'C'
*          'define p1tot = totprcp(t=13)'
*          'define p2tot = totprcp(t=25)'
*          'define p3run = totprcp(t='tindex')'
          'define p1tot = APCPsfc(t=13)'
          'define p2tot = APCPsfc(t=25)'
          'define p3run = APCPsfc(t='tindex')'
          'define prcptemp = p1tot + p2tot + p3run'
          rc = drawprcp(prcptemp)
        endif
      endif

    endif
  
  else

*    'define prcptemp = totprcp'
    'define prcptemp = APCPsfc'
    rc = drawprcp(prcptemp)

  endif


  bxrain = boxrain(prcptemp)
  if (bxrain > 0)
    totbxrain = totbxrain + bxrain
  else
    bxrain = 0
  endif

  'q gxinfo'
  xdum = sublin(result,3)
  ydum = sublin(result,4)
  _xl  = subwrd(xdum,4)
  _xr  = subwrd(xdum,6)
  _ylo = subwrd(ydum,4)
  _yhi = subwrd(ydum,6)

  xstart = _xl
  ystart = _ylo - 0.43

  rainstr='Box rain ('_units'):   Current hour = 'bxrain'   Total= 'totbxrain
  'set string 1 l 5'
  'set strsiz 0.13 0.13'
*  'draw string 'xstart' 'ystart' 'rainstr
  'draw string 1.25 'ystart' 'rainstr

  if (_drawstorm = y)
    'q ll2xy '_ctrlon' '_ctrlat
    xctr = subwrd(result,1)
    yctr = subwrd(result,2)
    'set line 1 1 3'
    'draw wxsym 41 'xctr' 'yctr' 0.28 1 3'
  endif

  if (_drawbox = y)
    'q ll2xy '_bxlonwe' '_bxlatso
    bxlo = subwrd(result,1)
    bylo = subwrd(result,2)
    'q ll2xy '_bxlonea' '_bxlatno
    bxhi = subwrd(result,1)
    byhi = subwrd(result,2)
    'set line 2 1 3'
    'draw rec 'bxlo' 'bylo' 'bxhi' 'byhi
  endif

  rc = plttitle(dtype,tindex)

  swap

  prompt 'Output graphic to file (y/n)?'
  pull cgraph

  if (cgraph = y)
    ctime    = gettime(tindex)
    currtime = convtime(ctime)
    'wi rain'currtime'.jpg'
  endif  

  prompt 'Continue(y/n)? '
  pull ccont

  if (ccont != n)
    tindex = tindex + 1
  endif


endwhile


*return
  

'c'
'set grads off'
'q dims'
rec=sublin(result,2)
lonstart=subwrd(rec,6)
lonend=subwrd(rec,8)
'q dims'
rec=sublin(result,3)
latstart=subwrd(rec,6)
latend=subwrd(rec,8)
'set lon 'lonstart' 'lonend
'set lat 'latstart' 'latend
'set gxout stat'
'q dims'
rec=sublin(result,2)
x1=subwrd(rec,11)
x2=subwrd(rec,13)
'q dims'
rec=sublin(result,3)
y1=subwrd(rec,11)
y2=subwrd(rec,13)

thresh1=0.001
thresh2=0.1
thresh3=0.12589
thresh4=0.15849
thresh5=0.19953
thresh6=0.25119
thresh7=0.31623
thresh8=0.39811
thresh9=0.50119
thresh10=0.63096
thresh11=0.79433
thresh12=1
thresh13=1.2589
thresh14=1.5849
thresh15=1.9953
thresh16=2.5119
thresh17=3.1623
thresh18=3.9811
thresh19=5.0119
thresh20=6.3096
thresh21=7.9433
thresh22=10
thresh23=12.589
thresh24=15.849
thresh25=19.953
thresh26=25.119
thresh27=31.623


if (dtype='npvu')
*  'define rainav1=sum(apcpsfc/25.4,t='tstart',t='tend')'
  'define rainav1=sum(totprcp/25.4,t='tstart',t='tend')'
endif
if (data='rcliper')
  'define rainav1=sum(rainrate,t='tstart',t='tend')'
endif
if (data='gfdl')
  'define rainav1=sum(totprcp/25.4,t='tstart',t='tend')'
endif
if (data='gfs')
  'define rainav1=sum(totprcp/25.4,t='tstart',t='tend')'
endif
if (data='eta')
  'define rainav1=sum(totprcp/25.4,t='tstart',t='tend')'
endif


'set mpdset hires'
'set gxout shaded'
'set csmooth on'
*if (color='c')
*  'set clevs 'thresh1' 'thresh2' 'thresh3' 'thresh4' 'thresh5' 'thresh6' 'thresh7' 'thresh8' 'thresh9' 'thresh10' 'thresh11' 'thresh12' 'thresh13' 'thresh14' 'thresh15
*  'set clevs -30 -10 -5 0 2 4 5 6 7 8 9 10 11 12 15'
*  'set clevs -10 -5 0 2 4 5 6 7 8 9 10 11 12 15'
  'set clevs .1 .25 .5 1 2 4 6 8 10'
  'set ccols 0 15 9 14 4 11 5 13 3 10 7 12 8 2 6 1'
*endif
'run set_prcp_levs.gs shaded '_units
if (color='g')
  'set clevs .1 .5 1 2 4 6 8 10'
  'set rgb 50 10 10 10 '
  'set rgb 51 40 40 40 '
  'set rgb 52 70 70 70 '
  'set rgb 53 100 100 100 '
  'set rgb 54 130 130 130 '
  'set rgb 55 160 160 160 '
  'set rgb 56 190 190 190 '
  'set rgb 57 220 220 220 '
  'set rgb 58 255 255 255 '
*  'set rbcols 50 51 52 53 54 55 56 57 58'
  'set rbcols 58 57 56 55 54 53 52 51 50'
endif

*'set xlab off'
*'set ylab off'
'set xlint 5'
'set ylint 5'
'set xlopts 1 5 .15'
'set ylopts 1 5 .15'
*'d 10.*log10(rainav1)'
'd smth9(rainav1)'
*'run cbar_rainpdf'
'run cbarn'
'set gxout contour'
'set ccolor 0'
*'set clevs .1 .5 1 2 4 6 8 10'
*'set clevs .1 .25 .5 1 2 4 6 8 10'
'run set_prcp_levs.gs contour '_units
'set clab off'
*'d smth9(rainav1)'
rc = plttita(dtype,iymdh,eymdh)

'mask1=const(const(maskout(rainav1,rainav1-'thresh1'),1),0,-u)'
'mask2=const(const(maskout(rainav1,rainav1-'thresh2'),1),0,-u)'
'mask3=const(const(maskout(rainav1,rainav1-'thresh3'),1),0,-u)'
'mask4=const(const(maskout(rainav1,rainav1-'thresh4'),1),0,-u)'
'mask5=const(const(maskout(rainav1,rainav1-'thresh5'),1),0,-u)'
'mask6=const(const(maskout(rainav1,rainav1-'thresh6'),1),0,-u)'
'mask7=const(const(maskout(rainav1,rainav1-'thresh7'),1),0,-u)'
'mask8=const(const(maskout(rainav1,rainav1-'thresh8'),1),0,-u)'
'mask9=const(const(maskout(rainav1,rainav1-'thresh9'),1),0,-u)'
'mask10=const(const(maskout(rainav1,rainav1-'thresh10'),1),0,-u)'
'mask11=const(const(maskout(rainav1,rainav1-'thresh11'),1),0,-u)'
'mask12=const(const(maskout(rainav1,rainav1-'thresh12'),1),0,-u)'
'mask13=const(const(maskout(rainav1,rainav1-'thresh13'),1),0,-u)'
'mask14=const(const(maskout(rainav1,rainav1-'thresh14'),1),0,-u)'
'mask15=const(const(maskout(rainav1,rainav1-'thresh15'),1),0,-u)'
'mask16=const(const(maskout(rainav1,rainav1-'thresh16'),1),0,-u)'
'mask17=const(const(maskout(rainav1,rainav1-'thresh17'),1),0,-u)'
'mask18=const(const(maskout(rainav1,rainav1-'thresh18'),1),0,-u)'
'mask19=const(const(maskout(rainav1,rainav1-'thresh19'),1),0,-u)'
'mask20=const(const(maskout(rainav1,rainav1-'thresh20'),1),0,-u)'
'mask21=const(const(maskout(rainav1,rainav1-'thresh21'),1),0,-u)'
'mask22=const(const(maskout(rainav1,rainav1-'thresh22'),1),0,-u)'
'mask23=const(const(maskout(rainav1,rainav1-'thresh23'),1),0,-u)'
'mask24=const(const(maskout(rainav1,rainav1-'thresh24'),1),0,-u)'
'mask25=const(const(maskout(rainav1,rainav1-'thresh25'),1),0,-u)'
'mask26=const(const(maskout(rainav1,rainav1-'thresh26'),1),0,-u)'
'mask27=const(const(maskout(rainav1,rainav1-'thresh27'),1),0,-u)'

'area1=amean(mask1,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area2=amean(mask2,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area3=amean(mask3,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area4=amean(mask4,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area5=amean(mask5,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area6=amean(mask6,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area7=amean(mask7,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area8=amean(mask8,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area9=amean(mask9,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area10=amean(mask10,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area11=amean(mask11,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area12=amean(mask12,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area13=amean(mask13,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area14=amean(mask14,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area15=amean(mask15,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area16=amean(mask16,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area17=amean(mask17,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area18=amean(mask18,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area19=amean(mask19,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area20=amean(mask20,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area21=amean(mask21,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area22=amean(mask22,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area23=amean(mask23,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area24=amean(mask24,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area25=amean(mask25,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area26=amean(mask26,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'
'area27=amean(mask27,lon='lonstart',lon='lonend',lat='latstart',lat='latend')'

'points1=area1*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points2=area2*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points3=area3*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points4=area4*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points5=area5*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points6=area6*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points7=area7*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points8=area8*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points9=area9*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points10=area10*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points11=area11*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points12=area12*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points13=area13*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points14=area14*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points15=area15*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points16=area16*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points17=area17*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points18=area18*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points19=area19*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points20=area20*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points21=area21*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points22=area22*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points23=area23*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points24=area24*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points25=area25*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points26=area26*('x2'-'x1'+1)*('y2'-'y1'+1)'
'points27=area27*('x2'-'x1'+1)*('y2'-'y1'+1)'

'bin1=100*(area1-area2)/area1'
'bin2=100*(area2-area3)/area1'
'bin3=100*(area3-area4)/area1'
'bin4=100*(area4-area5)/area1'
'bin5=100*(area5-area6)/area1'
'bin6=100*(area6-area7)/area1'
'bin7=100*(area7-area8)/area1'
'bin8=100*(area8-area9)/area1'
'bin9=100*(area9-area10)/area1'
'bin10=100*(area10-area11)/area1'
'bin11=100*(area11-area12)/area1'
'bin12=100*(area12-area13)/area1'
'bin13=100*(area13-area14)/area1'
'bin14=100*(area14-area15)/area1'
'bin15=100*(area15-area16)/area1'
'bin16=100*(area16-area17)/area1'
'bin17=100*(area17-area18)/area1'
'bin18=100*(area18-area19)/area1'
'bin19=100*(area19-area20)/area1'
'bin20=100*(area20-area21)/area1'
'bin21=100*(area21-area22)/area1'
'bin22=100*(area22-area23)/area1'
'bin23=100*(area23-area24)/area1'
'bin24=100*(area24-area25)/area1'
'bin25=100*(area25-area26)/area1'
'bin26=100*(area26-area27)/area1'

'number1=points1-points2'
'number2=points2-points3'
'number3=points3-points4'
'number4=points4-points5'
'number5=points5-points6'
'number6=points6-points7'
'number7=points7-points8'
'number8=points8-points9'
'number9=points9-points10'
'number10=points10-points11'
'number11=points11-points12'
'number12=points12-points13'
'number13=points13-points14'
'number14=points14-points15'
'number15=points15-points16'
'number16=points16-points17'
'number17=points17-points18'
'number18=points18-points19'
'number19=points19-points20'
'number20=points20-points21'
'number21=points21-points22'
'number22=points22-points23'
'number23=points23-points24'
'number24=points24-points25'
'number25=points25-points26'
'number26=points26-points27'

say 'Do you want percentage of points? (y/n)'
pull ans

if(ans = 'y')
'set gxout stat'
'd bin1'
rec=sublin(result,8)
val=subwrd(rec,4)
*say '% of points less than 'thresh1' = 'val
say '% of points between 'thresh1' and 'thresh2'= 'val
'd bin2'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh2' and 'thresh3'= 'val
'd bin3'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh3' and 'thresh4'= 'val
'd bin4'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh4' and 'thresh5'= 'val
'd bin5'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh5' and 'thresh6'= 'val
'd bin6'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh6' and 'thresh7'= 'val
'd bin7'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh7' and 'thresh8'= 'val
'd bin8'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh8' and 'thresh9'= 'val
'd bin9'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh9' and 'thresh10'= 'val
'd bin10'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh10' and 'thresh11'= 'val
'd bin11'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh11' and 'thresh12'= 'val
'd bin12'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh12' and 'thresh13'= 'val
'd bin13'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh13' and 'thresh14'= 'val
'd bin14'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh14' and 'thresh15'= 'val
'd bin15'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh15' and 'thresh16'= 'val
'd bin16'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh16' and 'thresh17'= 'val
'd bin17'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh17' and 'thresh18'= 'val
'd bin18'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh18' and 'thresh19'= 'val
'd bin19'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh19' and 'thresh20'= 'val
'd bin20'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh20' and 'thresh21'= 'val
'd bin21'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh21' and 'thresh22'= 'val
'd bin22'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh22' and 'thresh23'= 'val
'd bin23'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh23' and 'thresh24'= 'val
'd bin24'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh24' and 'thresh25'= 'val
'd bin25'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh25' and 'thresh26'= 'val
'd bin26'
rec=sublin(result,8)
val=subwrd(rec,4)
say '% of points between 'thresh26' and 'thresh27'= 'val
say ''
endif

say 'Do you want number of points? (y/n)'
pull ans

if(ans = 'y')
'set gxout stat'
'd number1'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh1' and 'thresh2'= 'val
'd number2'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh2' and 'thresh3'= 'val
'd number3'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh3' and 'thresh4'= 'val
'd number4'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh4' and 'thresh5'= 'val
'd number5'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh5' and 'thresh6'= 'val
'd number6'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh6' and 'thresh7'= 'val
'd number7'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh7' and 'thresh8'= 'val
'd number8'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh8' and 'thresh9'= 'val
'd number9'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh9' and 'thresh10'= 'val
'd number10'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh10' and 'thresh11'= 'val
'd number11'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh11' and 'thresh12'= 'val
'd number12'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh12' and 'thresh13'= 'val
'd number13'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh13' and 'thresh14'= 'val
'd number14'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh14' and 'thresh15'= 'val
'd number15'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh15' and 'thresh16'= 'val
'd number16'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh16' and 'thresh17'= 'val
'd number17'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh17' and 'thresh18'= 'val
'd number18'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh18' and 'thresh19'= 'val
'd number19'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh19' and 'thresh20'= 'val
'd number20'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh20' and 'thresh21'= 'val
'd number21'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh21' and 'thresh22'= 'val
'd number22'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh22' and 'thresh23'= 'val
'd number23'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh23' and 'thresh24'= 'val
'd number24'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh24' and 'thresh25'= 'val
'd number25'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh25' and 'thresh26'= 'val
'd number26'
rec=sublin(result,8)
val=subwrd(rec,4)
say 'number of points between 'thresh26' and 'thresh27'= 'val
endif

* Draw locations of center

say 'Plot center locations (y/n)?'
pull center
if(center='y')
say 'Enter lat of storm at starting time:'
pull lat1
say 'Enter lon of storm at starting time (West is negative):'
pull lon1
say 'Enter lat of storm at starting time + 6h:'
pull lat2
say 'Enter lon of storm at starting time + 6h:'
pull lon2
say 'Enter lat of storm at starting time + 12h:'
pull lat3
say 'Enter lon of storm at starting time + 12h:'
pull lon3
say 'Enter lat of storm at starting time + 18h:'
pull lat4
say 'Enter lon of storm at starting time + 18h:'
pull lon4
say 'Enter lat of storm at starting time + 24h:'
pull lat5
say 'Enter lon of storm at starting time + 24h:'
pull lon5

'set gxout line'
'set ccolor 0'
'set line 0 1 2'
'q ll2xy 'lon1' 'lat1
gridlon1=subwrd(result,1)
gridlat1=subwrd(result,2)
'q ll2xy 'lon2' 'lat2
gridlon2=subwrd(result,1)
gridlat2=subwrd(result,2)
'q ll2xy 'lon3' 'lat3
gridlon3=subwrd(result,1)
gridlat3=subwrd(result,2)
'q ll2xy 'lon4' 'lat4
gridlon4=subwrd(result,1)
gridlat4=subwrd(result,2)
'q ll2xy 'lon5' 'lat5
gridlon5=subwrd(result,1)
gridlat5=subwrd(result,2)
'draw mark 3 'gridlon1' ' gridlat1' .15'
'draw mark 3 'gridlon2' ' gridlat2' .15'
'draw mark 3 'gridlon3' ' gridlat3' .15'
'draw mark 3 'gridlon4' ' gridlat4' .15'
'draw mark 3 'gridlon5' ' gridlat5' .15'
'draw line 'gridlon1' ' gridlat1' ' gridlon2' ' gridlat2' ' gridlon3' ' gridlat3' ' gridlon4' ' gridlat4' ' gridlon5' ' gridlat5
endif

*'enable print rain'tstart'-'tend
*'enable print rain_'data
*'print'
*'disable print'
*'!gxps -c -i rain'tstart'-'tend' -o rain'tstart'-'tend'.ps'
*'!gxps -c -i rain_'data' -o rain_'data'.ps'

ptime    = gettime(tstart-1)
prevtime = convtime(ptime)

ctime    = gettime(tindex-1)
currtime = convtime(ctime)

'wi accumrain'prevtime'-'currtime'.jpg'

*'!rm rain'tstart'-'tend''
*'!rm rain_'data
*'!rm core'
'set gxout shaded'



************************
*                      *
************************
function convtime(grtime)

* Use this function to convert a date from the format of, for
* example, 12Z13FEB2003 to 2003021312.  The "hhZddMONYYYY"
* format is what you get from the output of 'q dims'.

hh=substr(grtime,1,2)
yyyy=substr(grtime,9,4)
dd=substr(grtime,4,2)

cmon=substr(grtime,6,3)

if (cmon = 'JAN' | cmon = 'jan'); gymdh=yyyy%01%dd%hh; endif
if (cmon = 'FEB' | cmon = 'feb'); gymdh=yyyy%02%dd%hh; endif
if (cmon = 'MAR' | cmon = 'mar'); gymdh=yyyy%03%dd%hh; endif
if (cmon = 'APR' | cmon = 'apr'); gymdh=yyyy%04%dd%hh; endif
if (cmon = 'MAY' | cmon = 'may'); gymdh=yyyy%05%dd%hh; endif
if (cmon = 'JUN' | cmon = 'jun'); gymdh=yyyy%06%dd%hh; endif
if (cmon = 'JUL' | cmon = 'jul'); gymdh=yyyy%07%dd%hh; endif
if (cmon = 'AUG' | cmon = 'aug'); gymdh=yyyy%08%dd%hh; endif
if (cmon = 'SEP' | cmon = 'sep'); gymdh=yyyy%09%dd%hh; endif
if (cmon = 'OCT' | cmon = 'oct'); gymdh=yyyy%10%dd%hh; endif
if (cmon = 'NOV' | cmon = 'nov'); gymdh=yyyy%11%dd%hh; endif
if (cmon = 'DEC' | cmon = 'dec'); gymdh=yyyy%12%dd%hh; endif

return gymdh


*-------------------------*
*
*-------------------------*
function gettime(ttt)

* Use this function to return the correct time
* that corresponds to the input time count....

'set t 'ttt
'q dims'
line5=sublin(result,5)

return subwrd(line5,6)

************************
*                      *
************************
function findctl (cstorm)

* This function reads the storminfo.txt file until it finds the
* storm that you requested, then it reads to get the starting 
* date for this case, as that is the date that is used in the
* name of the ctl file.

infofile = _rundir%'storminfo.txt'

foundstrm = n

while (1)

  res = read(infofile)
  rc  = sublin(res,1)
  if(rc != 0)
    if(rc = 2)
      say 'End of storm info file '
      say ' '
      break
    endif
    if(rc = 1); say 'rc=1: OPEN ERROR FOR 'infofile; endif
    if(rc = 8); say 'rc=8: 'infofile' OPEN FOR WRITE ONLY'; endif
    if(rc = 9); say 'rc=9: I/O ERROR FOR 'infofile; endif
    return 99
  endif

  rec    = sublin(res,2)

* We are reading until we find a match for the character
* storm name....

  rstorm = subwrd(rec,1)
  if (rstorm = cstorm)
*   Make sure that the storm is from the correct year....
    ryyyy = subwrd(rec,2)
    if (ryyyy = _iyyyy)
      foundstrm = y
      res = read(infofile)
      res = read(infofile)
      rc  = sublin(res,1)
      if (rc != 0)
        say '!!! ERROR READING FOR CTL FILE NAME FROM 'infofile
        say '!!! rc = 'rc
      endif
      rec     = sublin(res,2)
      ctlymdh = subwrd(rec,3)
      break
    endif
  endif

endwhile

* Be sure to close "infofile", the storminfo.txt file,
* since by closing it, that rewinds the file, so that 
* when the getbound function goes to read this same 
* file, it will be reading it from the beginning.

rc = close(infofile)

if (foundstrm = y)
  say '+++ Found storm 'cstorm' in 'infofile' with starting date of 'ctlymdh
  return ctlymdh
else
  say '!!! ERROR: STORM NOT FOUND FOR FINDCTL '
  say '!!!        STORM NAME = 'cstorm
  return 99
endif


************************
*                      *
************************
function getbnds (cstorm)
 
* This function reads the storminfo.txt file until it finds the 
* storm that you requested, then it reads the lat/lon boundary
* info for that storm.

infofile = _rundir%'storminfo.txt'

foundstrm = n

while (1)

  res = read(infofile)
  rc  = sublin(res,1)
  if(rc != 0)
    if(rc = 2)
      say 'End of storm info file '
      say ' '
      break
    endif
    if(rc = 1); say 'rc=1: OPEN ERROR FOR 'infofile; endif
    if(rc = 8); say 'rc=8: 'infofile' OPEN FOR WRITE ONLY'; endif
    if(rc = 9); say 'rc=9: I/O ERROR FOR 'infofile; endif
    return 99
  endif

  rec    = sublin(res,2)

  if (foundstrm = n)

*   We are reading until we find a match for the character
*   storm name....

    rstorm = subwrd(rec,1)
    if (rstorm = cstorm)
*     Make sure that the storm is from the correct year....
      ryyyy = subwrd(rec,2)
      if (ryyyy = _iyyyy)
        foundstrm = y
      endif
    endif

  else

*   Now that "foundstrm" = y, we read until the first instance
*   of "westlon", and then we get the boundaries from this and
*   the next 3 lines that we read in.
      
    first7 = substr(rec,1,7)

    if (first7 = 'westlon')

      tempwest = subwrd(rec,3) 
      _westlon = int(tempwest)

      res = read(infofile)
      rc  = sublin(res,1)
      if (rc != 0)
        say '!!! ERROR AAA READING FOR EASTLON FROM 'infofile
        say '!!! rc = 'rc
      endif
      rec    = sublin(res,2)
      tempeast = subwrd(rec,3) 
      _eastlon = int(tempeast)

      res = read(infofile)
      rc  = sublin(res,1)
      if (rc != 0)
        say '!!! ERROR BBB READING FOR NORTHLAT FROM 'infofile
        say '!!! rc = 'rc
      endif
      rec    = sublin(res,2)
      tempnorth = subwrd(rec,3)
      _northlat = int(tempnorth)

      res = read(infofile)
      rc  = sublin(res,1)
      if (rc != 0)
        say '!!! ERROR CCC READING FOR SOUTHLAT FROM 'infofile
        say '!!! rc = 'rc
      endif
      rec    = sublin(res,2)
      tempsouth = subwrd(rec,3)
      _southlat = int(tempsouth)

      break

    endif

  endif

endwhile

return


************************
*                      *
************************
function boxbound (cstorm,gymdh)
 
* This function reads the hourly best track file for the storm
* that you requested (cstorm) until it gets to the input hour 
* (gymdh), then it reads the lat/lon location for that storm 
* and gets the boundary for a box around the storm.  The size
* of the box around the storm is determined by the _boxsize
* parameter at the top of this script.

gyyyy = substr(gymdh,1,4)

btrackf = _btrackdir%'btrack.hourly.'cstorm%gyyyy'.txt'

foundtime = n

while (1)

  res = read(btrackf)
  rc  = sublin(res,1)
  if(rc != 0)
    if(rc = 2)
      say 'End of hourly best track file '
      say ' '
      break
    endif
    if(rc = 1); say 'rc=1: OPEN ERROR FOR 'btrackf; endif
    if(rc = 8); say 'rc=8: 'btrackf' OPEN FOR WRITE ONLY'; endif
    if(rc = 9); say 'rc=9: I/O ERROR FOR 'btrackf; endif
    return 99
  endif

  rec    = sublin(res,2)

* We are reading until we find a match for the date....

  rymdh = subwrd(rec,2)
  if (rymdh = gymdh)
    _ctrlat = subwrd(rec,3)
    _ctrlon = subwrd(rec,4)
    _ctrlon  = 360 - _ctrlon 
    _bxlatno = _ctrlat + _boxsize
    _bxlatso = _ctrlat - _boxsize
    _bxlonwe = _ctrlon - _boxsize
    _bxlonea = _ctrlon + _boxsize
    foundtime = y
    break
  endif

endwhile

if (foundtime = y)
  say rymdh'  center:  '_ctrlat' '_ctrlon'  box: '_bxlatso' '_bxlatno' '_bxlonwe' '_bxlonea
  return 0
else
  say '!!! ERROR: TIME NOT FOUND FOR gymdh= 'gymdh
  return 99
endif

*---------------------------*
*
*---------------------------*
function drawprcp (prcptemp)

'set grads off'
'set gxout shaded'
'set xlint 5'
'set ylint 5'
'set xlopts 1 5 .15'
'set ylopts 1 5 .15'
'run set_prcp_levs.gs shaded '_units

if (_units = inches)
  'd prcptemp/10 * 0.3937'
endif
if (_units = mm)
  'd prcptemp'
endif
if (_units = cm)
  'd prcptemp/10'
endif

'run cbarn.gs'
'set gxout contour'
'run set_prcp_levs.gs contour '_units
'set cthick 1'
'set clab off'

if (_units = inches)
  'd prcptemp/10 * 0.3937'
endif
if (_units = mm)
  'd prcptemp'
endif
if (_units = cm)
  'd prcptemp/10'
endif

return


*---------------------------*
*
*---------------------------*
function boxrain (prcptemp)

'set lon '_bxlonwe' '_bxlonea
'set lat '_bxlatso' '_bxlatno
'q dims'
rec=sublin(result,2)
x1=subwrd(rec,11)
x2=subwrd(rec,13)
'q dims'
rec=sublin(result,3)
y1=subwrd(rec,11)
y2=subwrd(rec,13)
totpoints=(x2-x1)*(y2-y1)
*say 'totpoints= 'totpoints

'set lon '_westlon' '_eastlon
'set lat '_southlat' '_northlat

if (_units = inches)
*  'define prcptemp = prcptemp / 10 * 0.3937'
  'mask=const(const(maskout(prcptemp/10*0.3937,prcptemp/10*0.3937-0.1),1),0,-u)'
  'area=amean(mask,lon='_bxlonwe',lon='_bxlonea',lat='_bxlatso',lat='_bxlatno')'
  'points=area*('x2'-'x1'+1)*('y2'-'y1'+1)'
  'd 'area
  frcarea = subwrd(result,4)
  say 'Fraction of area with rain > 0.1 in= '100*frcarea'%'

  'd 'points
  numpts = subwrd(result,4)
*  say '# of points with rain > 0.1 in= 'numpts

  'd asum(prcptemp,lon='_bxlonwe',lon='_bxlonea',lat='_bxlatso',lat='_bxlatno')/10 * 0.3937'
*  'd asum(prcptemp,lon='_bxlonwe',lon='_bxlonea',lat='_bxlatso',lat='_bxlatno')'
  boxprcp = subwrd(result,4)/totpoints
  boxprcpcond = subwrd(result,4)/numpts
  boxprcp = boxprcpcond
*  say 'boxprcp= 'boxprcp
*  say 'boxprcpcond= 'boxprcpcond
*  boxprcp = subwrd(result,4)
endif
if (_units = mm)
  'd asum(prcptemp,lon='_bxlonwe',lon='_bxlonea',lat='_bxlatso',lat='_bxlatno')'
  boxprcp = subwrd(result,4)
endif
if (_units = cm)
  'd asum(prcptemp,lon='_bxlonwe',lon='_bxlonea',lat='_bxlatso',lat='_bxlatno')/10'
  boxprcp = subwrd(result,4)
endif

return boxprcp



*****************
*               *
*****************
function plttitle (dtype,tindex)

tprev = tindex - 1
ptime    = gettime(tprev)
prevtime = convtime(ptime)

ctime    = gettime(tindex)
currtime = convtime(ctime)

yyyy = substr(plottime,1,4)

if (yyyy >= 2002)
  stage_num = 'Stage IV'
else
  stage_num = 'Stage II'
endif

xdiff  = _xr - _xl
xstart = (xdiff/2) + _xl
ystart = _yhi + 0.75
hsiz   = xdiff * 0.025
vsiz   = hsiz + 0.02

ystart = ystart - 0.28
ctitle = stage_num' accumulated precipitation ('_units')'
'set string 1 bc 6'
*'set strsiz 'hsiz' 'vsiz
'set strsiz 0.18 0.18'
'draw string 'xstart' 'ystart' 'ctitle

ystart = ystart - 0.32
ctitle = prevtime' - 'currtime
'draw string 'xstart' 'ystart' 'ctitle

return


function plttita (dtype,iymdh,eymdh)

yyyy = substr(plottime,1,4)

if (yyyy >= 2002)
  stage_num = 'Stage IV'
else
  stage_num = 'Stage II'
endif

xdiff  = _xr - _xl
xstart = (xdiff/2) + _xl
ystart = _yhi + 0.75
hsiz   = xdiff * 0.025
vsiz   = hsiz + 0.02

ystart = ystart - 0.28
ctitle = stage_num' accumulated precipitation ('_units')'
'set string 1 bc 6'
*'set strsiz 'hsiz' 'vsiz
'set strsiz 0.18 0.18'
'draw string 'xstart' 'ystart' 'ctitle

ystart = ystart - 0.32
*ctitle = prevtime' - 'currtime
ctitle = iymdh' - 'eymdh
'draw string 'xstart' 'ystart' 'ctitle

return

*****************
*               *
*****************
function mod(i,j)

* Math mod function

z=i/j
z=int(z)
a=i-z*j
* a=int(a)
return a


*****************
*               *
*****************
function int(stuff)

* Math int truncation function

res = ''
i = 1
c = substr(stuff,i,1)
while (c!='' & ('x'%c)!='x.')
  res = res%c
  i = i + 1
  c = substr(stuff,i,1)
endwhile
return res

